Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

# openvrml::sfint32 Class Reference

A 32-bit integer node field value. More...

`#include <openvrml/field_value.h>`

Inheritance diagram for openvrml::sfint32:
[legend]

List of all members.

## Public Types
typedef int32 | value_type
| Type of value.
## Public Member Functions
| sfint32 (int32 value=0) throw ()
| Construct.
| sfint32 (const sfint32 &sfi)
| Construct a copy.
virtual | ~sfint32 () throw ()
| Destroy.
sfint32 & | operator= (const sfint32 &sfi) throw ( std::bad_alloc )
| Assign.
const value_type & | value () const throw ()
| Access.
void | value (const value_type &val) throw ( std::bad_alloc )
| Mutate.
void | swap (sfint32 &sfi) throw ()
| Swap.
## Static Public Attributes
static const type_id | field_value_type_id = sfint32_id
| `field_value::type_id` for this class.
## Private Member Functions
virtual std::auto_ptr < field_value > | do_clone () const throw ( std::bad_alloc )
| Polymorphically construct a copy.
virtual sfint32 & | do_assign (const field_value &value) throw ( std::bad_cast )
| Virtual assignment.
virtual type_id | do_type () const throw ()
| Get the `field_value::type_id` associated with this class.
virtual void | print (std::ostream &) const
| Print to an output stream.
## Related Functions
(Note that these are not member functions.)
bool | operator== (const sfint32 &lhs, const sfint32 &rhs) throw()
| Compare for equality.
bool | operator!= (const sfint32 &lhs, const sfint32 &rhs) throw()
| Compare for inequality.
template<> void | swap (openvrml::sfint32 &a, openvrml::sfint32 &b)
| Swap the values of `a` and `b`.

## Detailed Description

A 32-bit integer node field value.

Model of
  Field Value

## Member Typedef Documentation

openvrml::sfint32::value_type

Type of value.

## Constructor & Destructor Documentation

openvrml::sfint32::sfint32 | ( | int32 | value = `0` | ) | throw ()`[explicit]`

Construct.

Parameters:

  `[in]` | value | initial value.

openvrml::sfint32::sfint32 | ( | const sfint32 & | sfi | ) |

Construct a copy.

Parameters:

  `[in]` | sfi | the instance to copy.

openvrml::sfint32::~sfint32 | ( |  | ) | throw ()`[virtual]`

Destroy.

## Member Function Documentation

openvrml::sfint32 & openvrml::sfint32::operator= | ( | const sfint32 & | sfi | ) | throw ( std::bad_alloc )

Assign.

Parameters:

  `[in]` | sfi | the value to assign.

Returns:
  a reference to the instance.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

const openvrml::sfint32::value_type & openvrml::sfint32::value | ( |  | ) | const throw ()

Access.

Returns:
  the integer value.

Reimplemented from openvrml::field_value.

void openvrml::sfint32::value | ( | const value_type & | val | ) | throw ( std::bad_alloc )

Mutate.

Parameters:

  `[in]` | val | the new value.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

void openvrml::sfint32::swap | ( | sfint32 & | sfi | ) | throw ()

Swap.

Parameters:

  `[in,out]` | sfi | the value to swap with this one.

std::auto_ptr< openvrml::field_value > openvrml::sfint32::do_clone | ( |  | ) | const throw ( std::bad_alloc )`[private, virtual]`

Polymorphically construct a copy.

Returns:
  a pointer to a copy of the object.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

Implements openvrml::field_value.

openvrml::sfint32 & openvrml::sfint32::do_assign | ( | const field_value & | value | ) | throw ( std::bad_cast )`[private, virtual]`

Virtual assignment.

Parameters:

  `[in]` | value | the new value to give the object.

Returns:
  a reference to the object.

Exceptions:

  | std::bad_cast | if `value` is not an sfint32.

openvrml::field_value::type_id openvrml::sfint32::do_type | ( |  | ) | const throw ()`[private, virtual]`

Get the `field_value::type_id` associated with this class.

Returns:
  `field_value::sfint32`.

Implements openvrml::field_value.

void openvrml::sfint32::print | ( | std::ostream & | out | ) | const`[private, virtual]`

Print to an output stream.

Parameters:

  `[in,out]` | out | an output stream.

Implements openvrml::field_value.

## Friends And Related Function Documentation

bool operator== | ( | const sfint32 & | lhs,
|  | const sfint32 & | rhs |
| ) |  |  | throw()`[related]`

Compare for equality.

Parameters:

  `[in]` | lhs | left-hand operand.
  `[in]` | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` have the same value; `false` otherwise.

bool operator!= | ( | const sfint32 & | lhs,
|  | const sfint32 & | rhs |
| ) |  |  | throw()`[related]`

Compare for inequality.

Parameters:

  `[in]` | lhs | left-hand operand.
  `[in]` | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` do not have the same value; `false` otherwise.

template<> void swap | ( | openvrml::sfint32 & | a,
|  | openvrml::sfint32 & | b |
| ) |  |  | `[related]`

Swap the values of `a` and `b`.

Does not throw.

Parameters:

  `[in,out]` | a |
  `[in,out]` | b |

## Member Data Documentation

const openvrml::field_value::type_id openvrml::sfint32::field_value_type_id = sfint32_id`[static]`

`field_value::type_id` for this class.